
/**
 * /!\ This file is automatically generated by QLALR from LGCInputLexerIO.g.
 * /!\ Don't edit it!
 */

#ifndef LGCINPUTLEXERIO_HPP
#define LGCINPUTLEXERIO_HPP

#include <unordered_set>

#include <ShareablePoints/ShareablePointsList.hpp>
#include <editors/text/LexerParser.hpp>

#include "LGCMeasures.hpp"
#include "table_lgcinputlexerio_p.h"

class LGCPlugin;

class LGCInputLexerIO : public LexerParser<Table_LGCInputLexerIO>
{
	Q_OBJECT

public:
	LGCInputLexerIO(QObject *parent = nullptr);
	virtual ~LGCInputLexerIO() override = default;

	// QsciLexerCustom
	enum Styles
	{
		/** Default */
		Default,
		/** Comment / ignored part */
		Comment,
		/** Functional Comment / ignored part / used by external software */
		FunctionalComment,
		/** not special stuff */
		Normal,
		// keywords
		/** Start or end keyword */
		StartEnd,
		/** Option keywords */
		DatumOption,
		CalculationOption,
		OutputOption,
		OptionParameter,
		/** Intruments */
		InstrumentType,
		InstrumentName,
		TargetName,
		/** Points */
		PointType,
		PointName,
		PointCoord,
		/** Frames */
		Frame,
		FrameName,
		/** Measures (same as Options) */
		MeasureType,
		MeasureParameter = OptionParameter,
		FrameParameter = OptionParameter,
	};
	// implemented in LGCInputLexerIO_impl.cpp
	virtual const char *language() const override { return "LGCPoint"; }
	virtual const char *keywords(int set) const override;
	virtual QString description(int style) const override;
	virtual const char *wordCharacters() const override;
	virtual bool defaultEolFill(int style) const override;
	QColor defaultColor(int style) const override;
	QFont defaultFont(int style) const override;
	QColor defaultPaper(int style) const override;

	// IShareablePointsListIO
	// implemented in LGCInputLexerIO_impl.cpp
	virtual const std::string &getMIMEType() const override;
	virtual ShareablePointsList read(const std::string &contents) override;
	virtual ShareableExtraInfos readExtraInfos(const std::string &contents) override;
	virtual ShareableFrame readFrame(const std::string &contents) override;
	virtual ShareableParams readParams(const std::string &contents) override;
	virtual ShareablePoint readPoint(const std::string &contents) override;
	virtual ShareablePosition readPosition(const std::string &contents) override;
	virtual std::string write(const ShareablePointsList &list) override;
	virtual std::string write(const ShareableExtraInfos &) override { return std::string(); }
	virtual std::string write(const ShareableFrame &frame) override;
	virtual std::string write(const ShareableParams &params) override;
	virtual std::string write(const ShareablePoint &point) override;
	virtual std::string write(const ShareablePosition &position) override;

	// LexerParser
	virtual void parse() override;

	// LGCInputLexerIO
	/** Return the parsed list. This should never be used, except rare occasions. */
	ShareablePointsList &getCurList() noexcept { return _curList; }
	/** Return LGCMeasures. */
	const LGCMeasures &lgcMeasures() const noexcept { return _measures; }
	/** Returns the map with lines that have toggleable sigmas. */
	std::unordered_map<int, std::unordered_set<QString>> &getSigmaLines() { return _sigmaLines; }
	/** Returns the position of the *END keyword */
	int getEndPos() const noexcept { return _endPos; }

protected:
	// TextLexer
	virtual QString calltip(int position, int indicatorType, const QString &indicator) const override;
	// LexerParser
	virtual void endLexer() override;

private:
	// LexerParser
	// generated in in LGCInputLexerIO_gen.cpp
	int nextToken(QStringRef value) override;
	void consumeRule(int ruleno) override;
	
	/** Convenience method for adding info annotations only during the second run. */
	inline void addAnnotation(const QString& annotation);
	/** Convenience method for adding annotations for point types. */
	inline void addPointAnnotation();
	
	bool checkBool(int symidx, const QString &name, Styles style = Styles::Normal);
	int checkInt(int symidx, const QString &name, int min = 0, int max = 0, Styles style = Styles::Normal);
	double checkDouble(int symidx, const QString &name, double min = 0, double max = 0, Styles style = Styles::Normal);

	// used for parsing, uses sym(1) and _currentLine
	void setOption(const std::string &key, char sep = '\n');
	void setInstrument(bool checkTarget = true);
	void setTarget();
	void setMeasure(const QString &measureName);
	void setPoint(const QString &type);
	void setFrame(const QString &frameName);
	void jumpTo(const LGCMeasures::MeasureMap &map, const QString &type, int idx = 1, QString key = "");
	void countMeasure(const QString &type, int pointSymbolIdx = 1);
	void showMeasure(const QString &type, const QString &point, int idx = 1);
	void reportRepeated(const QString &type, int idx = 1);
	inline bool isRootFrame(const std::string &name) const;

	/** tells if we are in lexer mode */
	bool lexerMode() { return _lexerMode || _firstRun || _secondRun; }

private:
	// Auto completion
	class LGCLexerAPIs;
	friend LGCLexerAPIs;
	/** Inline contexts */
	enum InlineCxt
	{
		CONSI = LGCInputLexerIO::CONSI,
		FMTP = LGCInputLexerIO::FMTP,
		JSON = LGCInputLexerIO::JSON,
		PUNC = LGCInputLexerIO::PUNC,
		FRAMESTART = LGCInputLexerIO::FRAMESTART
	};
	/** Contexts */
	enum Context
	{
		FRAME,
		MEASURES
	};

private:
	/** List of point used during deserializing. This shouldn't be used outside as it may be unvalid. Used for parsing */
	ShareablePointsList _curList;
	/** Current frame during parsing */
	ShareableFrame *_curFrame = nullptr;
	/** TMP variable. Used for parsing */
	QString _curTmp;
	QString _curTmp2; // for ORIE
	QString _curTmpFrame; // for FRAMEs ENDFRAME indicator
	QString _curPointMeasure;
	const char _functionalComment = '$';
	// maps for ctrl+click
	LGCMeasures _measures;
	/** Some observations may be defined before the point definition appears (e.g. when using FRAMEs). They are counted and added when they finally appear. */
	std::unordered_map<QString, std::unordered_map<QString, int>> _missingPointObservations;
	/**
	 * True if we are in the first run.
	 * We run the parsing twice if we are in lexer mode to get all the point definitions in the first run and show errors in the second run if some points
	 * are used while they are not defined.
	 */
	bool _firstRun = false;
	/** True if we are in the second run. */
	bool _secondRun = false;
	/** used when (de)serializing and write a SPL in LGC format */
	bool _firstFrameWritten = false;
	/** used when (de)serializing and write a SPL in LGC format */
	bool _firstPointWritten = false;
	/** used to ignore any content appearing after *END or *FIN keyword */
	bool _isPostEnd = false;
	/** *END keyword position */
	int _endPos = -1;
	/** Mapping between lines and possible sigma keyword at the given line */
	std::unordered_map<int, std::unordered_set<QString>> _sigmaLines;
};

#endif // LGCINPUTLEXERIO_HPP
